; -*- fundamental -*-
; $Id: printer.asm,v 1.1 2004/09/09 07:56:39 hpa Exp $
;
; Simple option ROM for printer for ABC80; this is not authentic, but
; was done for the FPGA project.  This assumes the following hardware
; interface:
;
; - ABC-bus select code 24 decimal;
; OUT 0 - (OUT)  data
; OUT 2 - (C1)   send break (data = # of bit times + 1)
; OUT 3 - (C2)   serial port speed divider+1 LOW
; OUT 4 - (C3)   serial port speed divider+1 HIGH
; INP 1 - (STAT): bit 0 - sending data
;                 bit 1 - sending break
;                 bit 2 - flow control
;
; Baud rate = 25 MHz / (C3:C2 + 1)
;
jptable
	jp (open)			; OPEN
	jp (open)			; PREPARE
	jp (close)			; CLOSE
	jp (nothere)			; INPUT
	jp (print)			; PRINT
	jp (nothere)			; Block to buf
	jp (nothere)			; Block from buf
	jp (nothere)			; DELETE???
	jp (nothere)			; RENAME???

open
	ld a,#24			; Select code
	out (#1),a

	in a,(#1)
	and #0xf8
	jr nz,notready
	
	ld a,#216			; 115200 baud
	out (#3),a
	xor a
	out (#4),a

done
	ld a,(iy+0x15)			; Restore select
	out (#1),a

	and a
	ret

notready
	rst 0x10
	byte 0xb3			; Err 51 = enheten upptagen



close
	ld a,#24			; Select code
	out (#1),a

close_wait
	in a,(#1)
	and a
	jr nz,close_wait

	ld a,#31			; BREAK for 32 bit times
	out (#2),a

	jr done


print
	ld a,#24			; Select code
	out (#1),a

print_loop
	ld a,b
	or c
	jr z,done

print_wait
	in a,(#1)
	and a
	jr nz,print_wait

	ld a,(hl)
	out (#0),a

	dec bc
	inc hl
	jr print_loop

nothere
	rst 0x10
	byte 0xb4			; Err 52 = ej till denna enhet

